require "stringutil"

local function doResidental ( data, capacity )
	local ruleCapacity = math.floor(capacity / 4 + 0.5)
	if (ruleCapacity > 0) then
		data.stocks = {}
		data.stockRules = {}
		local cargoTypes = {"MAIL"}
		local inputs = { { { 1, } },  }
		
		for i = 1, 1 do
			data.stocks[i] = {
				cargoType = cargoTypes[i],
				type = "RECEIVING",
				edges = { },
				moreCapacity = ruleCapacity
			}
			data.stockRules[i] = {
				input = inputs[i],
				output = { { 0, } },
				capacity = ruleCapacity
			}
		end
	end			

	return data
end

local function constructionHandler (fileName, data)
	local fn = data.updateFn

	data.updateFn = function(params)
		local ole_landUseType = params.landUseType or -1
		result = fn(params)
		if ((string.ends( fileName, "ole_townbuilding.con") or string.ends( fileName, "ole_townbuilding_no_collision.con")) and (ole_landUseType == 0)) then
			return doResidental (result, result.personCapacity.capacity)
		elseif (data.type == "TOWN_BUILDING" and (data.townBuildingParams.landUseType == "RESIDENTIAL")) then
			result = doResidental (result, params.capacity)
			result.cost = 1000
			result.bulldozeCost = 100
		end
	end

	return result
end

function data()
return {
	info = {
		minorVersion = 0,
		severityAdd = "NONE",
		severityRemove = "WARNING",
		name = (_("Post")),
		description = _("Post"),
		authors = {
			{
			  name = "nown",
			  role = "CREATOR",
			  text = "",
			}
		},
		tags = {"Script Mod"},
		modid = "nown_post_1",
	},
	runFn = function (settings)
		addModifier( "loadConstruction", constructionHandler )
	end,
}
end